import { APIResource } from '../../resource';
import { type RequestOptions } from '../../../core';
export declare class Rooms extends APIResource {
    create(params: CreateRoomReq, options?: RequestOptions): Promise<CreateRoomData>;
}
export interface CreateRoomReq {
    bot_id: string;
    conversation_id?: string;
    voice_id?: string;
    connector_id: string;
    uid?: string;
    workflow_id?: string;
    config?: {
        video_config?: {
            stream_video_type: 'main' | 'screen';
        };
    };
}
export interface CreateRoomData {
    token: string;
    uid: string;
    room_id: string;
    app_id: string;
}
