import BaseWsTranscriptionClient from './base';
import { type AIDenoiserProcessorLevel, type AIDenoiserProcessorMode } from '../recorder/pcm-recorder';
declare class WsTranscriptionClient extends BaseWsTranscriptionClient {
    private isRecording;
    private connect;
    destroy(): void;
    getStatus(): "recording" | "ended" | "paused";
    start(): Promise<void>;
    /**
     * 停止录音，提交结果
     */
    stop(): void;
    /**
     * 暂停录音（保留上下文）
     */
    pause(): void;
    /**
     * 恢复录音
     */
    resume(): void;
    getDenoiserEnabled(): boolean | undefined;
    setDenoiserEnabled(enabled: boolean): Promise<void>;
    setDenoiserMode(mode: AIDenoiserProcessorMode): Promise<void>;
    setDenoiserLevel(level: AIDenoiserProcessorLevel): Promise<void>;
}
export default WsTranscriptionClient;
