declare global {
    interface Window {
        __denoiser: AIDenoiserExtension;
    }
}
import { AIDenoiserExtension } from 'agora-extension-ai-denoiser';
/**
 * Check audio device permissions
 * @returns {Promise<{audio: boolean}>} Whether audio device permission is granted
 */
export declare const checkDevicePermission: () => Promise<{
    audio: boolean;
}>;
/**
 * Get list of audio devices
 * @returns {Promise<{audioInputs: MediaDeviceInfo[], audioOutputs: MediaDeviceInfo[]}>} Audio devices
 */
export declare const getAudioDevices: () => Promise<{
    audioInputs: MediaDeviceInfo[];
    audioOutputs: MediaDeviceInfo[];
}>;
/**
 * Convert floating point numbers to 16-bit PCM
 * @param float32Array - Array of floating point numbers
 * @returns {ArrayBuffer} 16-bit PCM
 */
export declare const floatTo16BitPCM: (float32Array: Float32Array) => ArrayBuffer;
/**
 * Check if device is mobile
 * @returns {boolean} Whether device is mobile
 */
export declare const isMobile: () => boolean;
/**
 * Check if AI denoising is supported
 * @param assetsPath - Public path for denoising plugin
 * @returns {boolean} Whether AI denoising is supported
 */
export declare const checkDenoiserSupport: (assetsPath?: string) => boolean;
